void main() {
    // All singletons.
    for (q1)
        for (q2)
            if (q3) 
                while (q4)
                    for (q5)
                        a();
            else
                if
                    while
                        for
                            b();
                else
                    c();
    ok1();
    // With some braces.
    for (q1)
        for (q2)
            if (q3) {
                while (q4)
                    for (q5)
                        a();
            }
            else {
                if
                    while
                        for
                            b();
                else
                    c();
            }
    ok2();
    // With challenging else requirements.
    if (d)                        // B1 S0
        while (w)                 // B1 S1
            if (c) {              // B1 S2 --------+
                if (b)            // B2 S0 -----+  |
                    for (f)       // B2 S1      |  |
                        if (a)    // B2 S2 ---+ |  |
                            a++;  // B2 S3    | |  |
                        else      // B2 S2 ---+ |  |
                            a();  // B2 S3      |  |
                else              // B2 S0 -----+  |
                    b();          // B2 S1         |
            }                     // B2 S1         |
            else                  // B1 S2 --------+
                c();              // B1 S3
    else                          // B1 S0
        d();                      // B1 s1
    return;                       // B1 S0
}
